# Copyright(c) 2000-2006 Association of Universities for Research in Astronomy, Inc.

procedure gemhedit (image, field, value, comment)

# Edit FITS header keyword:
# Adding comment if keyword does not already exist
# If keyword already exists, hedit is used and comment ignored
# Should be safe and never return status=1 unless image does not exist
#
# Version  May 31, 2001   IJ, v1.2 release
#          Mar  3, 2002   IJ, v1.3 release
#          Sept 20,2002   IJ, v1.4 release
#          Feb 3, 2003    IJ  fix segmentation violation bug under Linux7.3
#	   Aug 11, 2003   KL, Added 'addonly-' parameter to hedit calls

char    image   {prompt="Input image"}
char    field   {prompt="Keyword name"}
char    value   {prompt="Value"}
char    comment {prompt="Comment to add for keyword"}
int     status  {0,prompt="Exit status"}

begin

    char    l_image, l_field, l_value, l_comment
    char    l_keycheck
    
    l_image = image ; l_field=field ; l_value=value ; l_comment=comment

    # Make sure the field name is in upper case
    print (l_field) | translit ("STDIN","a-z","A-Z",del-,coll-) | scan (l_field)

    # Initialize param
    status = 0

    if (no==imaccess(l_image)) {
        print("ERROR - GEMHEDIT: Image "//l_image//" not found")
        status=1
        bye
    }

    # Cut keyword to eight if it is longer
    if (strlen(l_field)>8)
        l_field=substr(l_field,1,8)

    # check if keyword already exists, use hedit if keyword already exists
    l_keycheck=""
    hselect(l_image,l_field,yes) | scan(l_keycheck)
 
    if (l_keycheck!="") {
        nhedit(l_image,l_field,l_value, comment=".", comfile="NULL", \
            after="", before="", update+, add-, addonly-, del-, \
            verify-, show-)
    } else { 

        nhedit (l_image, l_field, l_value, comment=l_comment, \
            comfile="NULL", after="", before="", update+, add+, addonly-, \
            delete-, verify-, show-)

    } # end of using nhedit

end
